#! /usr/bin/python3 

import csv
import codecs
import simplekml
import re

INPUT_FILE = "logger.txt"
OUTPUT_FILE = "logger.kml"

########################
# Latitude Translation #
# (from NMEA to KML)   #
########################
def TransLat(s):
   a = re.search('([0-9.]*)([NS])',s,re.IGNORECASE)
   direction = ( -1.0 if (a.group(2)=='S') else 1.0)
   value = float(a.group(1)[0:2])
   value += float(a.group(1)[2:9]) / 60.0
   value *= direction
   return value 
   
#########################
# Longitude Translation #
# (from NMEA to KML)    #
#########################
def TransLon(s):
    a = re.search('([0-9.]*)([WE])',s,re.IGNORECASE)
    direction = ( -1.0 if (a.group(2)=='W') else 1.0)
    value = float(a.group(1)[0:3])
    value += float(a.group(1)[3:10]) / 60.0
    value *= direction
    return value

############################
# Convert INPUT_FILE (CSV) #
# to OUTPUT_FILE (KML)     #
############################
if __name__ == "__main__" :

    inputfile = csv.reader(open(INPUT_FILE,'r'))
    kml = simplekml.Kml()
    n = 0

    for row in inputfile:
        kml.newpoint(name=str(n),coords=[(TransLon(row[2]),TransLat(row[1]))])
        n = n + 1

    kml.save(OUTPUT_FILE)


